-------------------------------------------------------------------------------
--	DumpJunk
--      Converted to use Ace3
-------------------------------------------------------------------------------

local options = { 
    type='group',
    args = {
        autoSell = {
	        type = 'toggle',
	        name = 'Auto sell',
	        desc = 'Automatically sell items when interacting with vendors',
	        get = function ()
	           	return DumpJunk.db.profile.autoSell
	        end,
	        set = function (v)
	           	DumpJunk.db.profile.autoSell = v
	        end,
	        },
	   silentMode = {
	        type = 'toggle',
	        name = 'Silent mode',
	        desc = 'Toggles silent mode',
	        get = function ()
		    	  return DumpJunk.db.profile.silent
		    end,
		    set = function (v)
		    	  DumpJunk.db.profile.silent = v
	        end,
	    },
    	destroyJunk = {
    		type = 'execute',
    		name = 'Destroy junk items',
    		desc = 'Destroy all junk items in your inventory',
    		func = function ()
    			StaticPopup_Show ("DumpJunk_DESTROY")
    		end,
v    	},
    	list = {
    		type = 'execute',
    		name = 'List exceptions',
    		desc = 'List all exception items in chat',
    		func = 'ListExceptions',
    	},
    	purge = {
    		type = 'execute',
    		name = 'Purge exceptions',
    		desc = 'Purge exception items list',
    		func = 'PurgeExceptions',
    	},
    	add = {
    		type = 'text',
    		name = 'Add exception',
    		desc = 'Add an item to the exception list',
    		set = 'AddException',
    		get = false,
    		usage = 'add <Shift-Click on an item>',
    	},
    	remove = {
    		type = 'text',
    		name = 'Remove exception',
    		desc = 'Remove an item from the exception list',
    		set = 'RemoveException',
    		get = false,
    		usage = 'remove <item number from the list>, or remove <Shift-Click on an item>',
    	},
    	
    },
}

-- DumpJunk = AceLibrary("AceAddon-3.0"):new("AceConsole-3.0", "AceEvent-3.0", "AceDB-3.0")

if (LibStub) then
   DumpJunk = LibStub("AceAddon-3.0"):NewAddon("DumpJunk", "AceConsole-3.0", "AceEvent-3.0")
end

if (not DumpJunk) then
   DEFAULT_CHAT_FRAME:AddMessage(' Please get and install the Ace3 libraries')
end

-- DumpJunk:RegisterChatCommand("/dumpjunk", "/dj", options)
DumpJunk:RegisterChatCommand("/dumpjunk", options)

DumpJunk.rotation = 0
DumpJunk.rotrate = 0
DumpJunk.totalProfit = 0


-- print with prefix
function DumpJunk:Print2(arg1, arg2)
  local caption;
  local msg;

  if (arg2) then 
    caption = arg1; 
    msg = arg2;
  else 
    caption = "DumpJunk";
    msg = arg1;
  end
  DEFAULT_CHAT_FRAME:AddMessage("|c00bfffff" .. caption .. "|r: " .. msg,
    0.0, .8, 1)
end

-- cycle through all junk items
function DumpJunk:ForAllJunk(action, message)
  local total_value = 0;

  for bag = 0, NUM_BAG_FRAMES do
    if GetContainerNumSlots(bag) > 0 then
      for slot = 0, GetContainerNumSlots(bag) do
        local texture, itemCount, locked, quality = 
          GetContainerItemInfo(bag, slot);

        if (quality ~= nil) then
          local linkcolor = 
            self:ProcessLink(GetContainerItemLink(bag, slot));

          -- self:Print(texture .. " Quality = " .. quality )

          if (linkcolor == 1) then
            if (not DumpJunk.db.profile.silent and message ~= nil) then
              self:Print(message(bag, slot))
            end
            total_value = total_value + (action(bag, slot) * itemCount)
          end
        end
      end
    end
  end

  return total_value;
end

-- destroy all junk items in inventory
function DumpJunk:DestroyJunk()
   if not DumpJunk.db.profile.silent then
    DumpJunk:Print("Destroying all junk items")
   end
   DumpJunk:ForAllJunk(
  function(bag, slot) 
    PickupContainerItem(bag, slot);
    if (CursorHasItem()) then
      -- DeleteCursorItem()
      PutItemInBackpack()
    end
    return 0
  end,
  function(bag, slot)
   if not DumpJunk.db.profile.silent then 
    return "Destroyed " .. GetContainerItemLink(bag, slot)
   else
    return 0
   end 
  end)
  if not DumpJunk.db.profile.silent then
    DumpJunk:Print("Done destroying?")
  end
end

local function GetSellValue(id)
   return select(11, GetItemInfo(id))
end

function DumpJunk:CalculatePrices()
  return DumpJunk:ForAllJunk(
  function (bag, slot)
    local link = GetContainerItemLink(bag, slot)
    local val = 0
    local found, _, idstr = string.find(link, "^|c%x+|Hitem:(%d+):.*|h%[.+%]")
    if (found) then
      if (GetSellValue) then -- do we have GetSellValue?
        self:Print("Checking price through GetSellValue")
      	val = GetSellValue(tonumber(idstr))
      end
      self:Print2("Value for " .. link .. "is " .. val)
      if (val == 0) then
        self:Print("Could not find value for " .. link)
      end
      return val;
    else
      self:Print("Error parsing item link.");
      return 0;
    end
  end)
end

function DumpJunk:OnEnable()
--    DumpJunk:Print2("In OnEnable")
--   self:RegisterEvent("PLAYER_LOGIN")
--    self:RegisterEvent("VARIABLES_LOADED")
    self:RegisterEvent("MERCHANT_SHOW")
   DumpJunk.Init()
    -- fancy button
--    DumpJunk_TreasureModel:SetModel("World/Generic/PassiveDoodads/TreasurePiles/GoldPileLarge01.m2");
--    DumpJunk_TreasureModel:SetScale(1);
--    DumpJunk_TreasureModel:SetPosition(-1, -.5, 0);
end

function DumpJunk.Init()

-- function DumpJunk:VARIABLES_LOADED()
--    DumpJunk:Print2("In Variables_Loaded")

local defaults = {
   profile = {
	autoSell = false,
	silent = false,
	exceptions = {},
	totalJunkqty = 0,
	totalJunkprice = 0
   }
}   

DumpJunk.db = LibStub("AceDB-3.0"):New("DumpJunkSV", defaults, true)

--   dump('Debug db = ' , DumpJunk.db)

  if (GetSellValue) then
    DumpJunk:Print("Found GetSellValue - Using for vendor prices.")
    StaticPopupDialogs["DumpJunk_DESTROY"] = {
    text = "Destroy items?",
    button1 = TEXT(YES),
    button2 = TEXT(NO),
    OnAccept = function ()
        DumpJunk:DestroyJunk()
    end,
    timeout = 0,
    whileDead = 0,
    hideOnEscape = 1,
    hasMoneyFrame = 1,
    OnShow = function ()
       value = DumpJunk:CalculatePrices()
      MoneyFrame_Update(self:GetName().."MoneyFrame", value)
    end
  }
  else
    DumpJunk:Print("No prices for items available")
    StaticPopupDialogs["DumpJunk_DESTROY"] = {
    text = "Destroy items?",
    button1 = TEXT(YES),
    button2 = TEXT(NO),
    OnAccept = function ()
      DumpJunk:DestroyJunk()
    end,
    timeout = 0,
    whileDead = 0,
    hideOnEscape = 1
    }
  end  
end

function DumpJunk:MERCHANT_SHOW()
--    DumpJunk:Print("MERCHANT_SHOW")
	if (DumpJunk.db.profile.autoSell) then
		self:SellJunk()
	end

   MerchantFrameLootFilter:SetPoint("TOPRIGHT", -45, -32)
--   MerchantFrameLootFilter:SetPoint("TOPRIGHT", 0, -48)
--   DumpJunk_AutosellButton:SetPoint("TOPRIGHT", -4, 348)

	DumpJunk_TreasureModel:SetModel("World/Generic/PassiveDoodads/TreasurePiles/GoldPileMedium01.m2")
	DumpJunk_TreasureModel:SetScale(1)
	DumpJunk_TreasureModel:SetPosition(-1, -.5, 0)
	DumpJunk.rotation = 0
end

function DumpJunk:ProcessLink(link)

-- printable = gsub(link, "\124", "\124\124");
-- ChatFrame1:AddMessage("Here's what it really looks like: \"" .. printable .. "\"");

  -- for color, item, name in string.gmatch(link, "|c(%x+)|Hitem:(%d+:%d+:%d+:%d+:%d+:%d+:%d+:.%d+:%d+:%d+)|h%[(.-)%]|h|r") do


   local name, _, quality = GetItemInfo(link)

--   DumpJunk:Print( item .. " ".. color .." " ..name)

    if (quality == 0) then
      for i=1,table.getn(self.db.profile.exceptions) do
        if (link == self.db.profile.exceptions[i]) then
          return 0;
        end
      end

      return 1;
    end

    if (quality == 1) then
      for i=1,table.getn(self.db.profile.exceptions) do
        if (link == self.db.profile.exceptions[i]) then
          return 1;
        end
      end

      return 0;
    end

    return 0;
--  end

end

function DumpJunk:AddException(name)
	self.db.profile.exceptions[table.getn(self.db.profile.exceptions) + 1] = name
	self:Print(name .. " added to global exception list.")	
end

function DumpJunk:RemoveException(name)
    if (string.len(name) < 6) then
      local n = tonumber(name);
      if (n == nil) then return; end
      if (n < 1) then self:Print("Invalid number (n<0)");return; end
      if (n > table.getn(self.db.profile.exceptions)) then self:Print("Invalid number");return; end
      self:Print("Removed " .. self.db.profile.exceptions[n] ..
                       " from exceptions list.");
      table.remove(self.db.profile.exceptions, n)
      return
    end
	local removed = false
	local exception
	local _, _, linkID = string.find(name,"item:(%d+)")
	for k,v in pairs(self.db.profile.exceptions) do
		_, _, exception = string.find(v,"item:(%d+)")
		if (exception == linkID) then
			table.remove( self.db.profile.exceptions, k)
			removed = true
			end
		end
	if removed then
		self:Print("Removed " .. name .. " from exceptions list.")
	else
	   self:Print("No such exception found")
    end
end

function DumpJunk:PurgeExceptions()
    local count=0
    for k,v in pairs(self.db.profile.exceptions) do
				self.db.profile.exceptions[k] = nil
				count = count + 1
	end
	if (count == 1) then self:Print(count .. " exception deleted"); end
	if (count > 1) then self:Print(count .. " exceptions deleted"); end
	if (count < 1) then self:Print("Exception list already empty"); end
end

function DumpJunk:ListExceptions()
	if ( self.db.profile.exceptions ) then
	   local total = table.getn(self.db.profile.exceptions); 
	   if (total > 0) then
		  self:Print("Exception list (" .. total .." total):")
		  for k,v in pairs(self.db.profile.exceptions) do
    			self:Print(k .. ". " .. v)
    	  end
	    else
	       self:Print("No exceptions found")
	    end
	else
	   self:Print("No exceptions found")
    end
end

DumpJunk.junkCount = 0
function DumpJunk:SellJunk()
  if ((DumpJunk.totalProfit > 0) and (not self.db.profile.autoSell)) then
	self.db.profile.totalJunkprice = self.db.profile.totalJunkprice + DumpJunk.totalProfit
  elseif self.db.profile.autoSell then
    self.db.profile.totalJunkprice = self.db.profile.totalJunkprice + DumpJunk:CalculatePrices()
  end
  DumpJunk:ForAllJunk(
  function(bag, slot) 
--    PickupContainerItem(bag, slot); 
--    MerchantItemButton_OnClick("LeftButton");
    ShowMerchantSellCursor(1)
    UseContainerItem(bag, slot);  -- fix for 3.0, but maybe a better/safer way yet?
    DumpJunk.junkCount = DumpJunk.junkCount + 1
    return 0;
  end,
  function(bag, slot) 
    return "Sold " .. GetContainerItemLink(bag, slot) 
  end)
  self.db.profile.totalJunkqty = self.db.profile.totalJunkqty + DumpJunk.junkCount
  DumpJunk.junkCount = 0
end

-- fancy button

function DumpJunk.RotateModel(self, elapsed)
  if (DumpJunk.rotrate > 0) then 
    DumpJunk.rotation = DumpJunk.rotation + (elapsed * DumpJunk.rotrate); 
  end
  DumpJunk_TreasureModel:SetRotation(DumpJunk.rotation);
end

function DumpJunk.AddCoinTooltip(self, amount)
  if (amount) then
    DumpJunk.totalProfit = DumpJunk.totalProfit + amount
  end
end

function DumpJunk:CalculateFromTooltip()
  DumpJunk:ForAllJunk(
  function(bag, slot)
   DumpJunkTooltip:ClearLines();
   DumpJunkTooltip:SetBagItem(bag, slot);  
   return 0
  end)
end
